diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ApplicationInfo.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ApplicationInfo.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ApplicationInfo.java	2017-09-27 02:07:48.935736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ApplicationInfo.java	2017-09-21 13:22:22.396806000 +0900
@@ -22,6 +22,7 @@
 import android.os.Parcel;
 import android.os.Parcelable;
 import android.text.TextUtils;
+import android.util.Log;
 import android.util.Printer;
 
 import com.android.internal.util.ArrayUtils;
@@ -37,60 +38,60 @@
  * &lt;application&gt; tag.
  */
 public class ApplicationInfo extends PackageItemInfo implements Parcelable {
-    
+
     /**
      * Default task affinity of all activities in this application. See 
      * {@link ActivityInfo#taskAffinity} for more information.  This comes 
      * from the "taskAffinity" attribute. 
      */
     public String taskAffinity;
-    
+
     /**
      * Optional name of a permission required to be able to access this
      * application's components.  From the "permission" attribute.
      */
     public String permission;
-    
+
     /**
      * The name of the process this application should run in.  From the
      * "process" attribute or, if not set, the same as
      * <var>packageName</var>.
      */
     public String processName;
-    
+
     /**
      * Class implementing the Application object.  From the "class"
      * attribute.
      */
     public String className;
-    
+
     /**
      * A style resource identifier (in the package's resources) of the
      * description of an application.  From the "description" attribute
      * or, if not set, 0.
      */
-    public int descriptionRes;    
-    
+    public int descriptionRes;
+
     /**
      * A style resource identifier (in the package's resources) of the
      * default visual theme of the application.  From the "theme" attribute
      * or, if not set, 0.
      */
     public int theme;
-    
+
     /**
      * Class implementing the Application's manage space
      * functionality.  From the "manageSpaceActivity"
      * attribute. This is an optional attribute and will be null if
      * applications don't specify it in their manifest
      */
-    public String manageSpaceActivityName;    
-    
+    public String manageSpaceActivityName;
+
     /**
      * Class implementing the Application's backup functionality.  From
      * the "backupAgent" attribute.  This is an optional attribute and
      * will be null if the application does not specify it in its manifest.
-     * 
+     *
      * <p>If android:allowBackup is set to false, this attribute is ignored.
      */
     public String backupAgentName;
@@ -124,7 +125,7 @@
      * device's system image.
      */
     public static final int FLAG_SYSTEM = 1<<0;
-    
+
     /**
      * Value for {@link #flags}: set to true if this application would like to
      * allow debugging of its
@@ -133,7 +134,7 @@
      * android:debuggable} of the &lt;application&gt; tag.
      */
     public static final int FLAG_DEBUGGABLE = 1<<1;
-    
+
     /**
      * Value for {@link #flags}: set to true if this application has code
      * associated with it.  Comes
@@ -141,7 +142,7 @@
      * android:hasCode} of the &lt;application&gt; tag.
      */
     public static final int FLAG_HAS_CODE = 1<<2;
-    
+
     /**
      * Value for {@link #flags}: set to true if this application is persistent.
      * Comes from {@link android.R.styleable#AndroidManifestApplication_persistent
@@ -162,20 +163,20 @@
      * android:allowTaskReparenting} of the &lt;application&gt; tag.
      */
     public static final int FLAG_ALLOW_TASK_REPARENTING = 1<<5;
-    
+
     /**
      * Value for {@link #flags}: default value for the corresponding ActivityInfo flag.
      * Comes from {@link android.R.styleable#AndroidManifestApplication_allowClearUserData
      * android:allowClearUserData} of the &lt;application&gt; tag.
      */
     public static final int FLAG_ALLOW_CLEAR_USER_DATA = 1<<6;
-    
+
     /**
      * Value for {@link #flags}: this is set if this application has been
      * install as an update to a built-in system application.
      */
     public static final int FLAG_UPDATED_SYSTEM_APP = 1<<7;
-    
+
     /**
      * Value for {@link #flags}: this is set of the application has specified
      * {@link android.R.styleable#AndroidManifestApplication_testOnly
@@ -190,15 +191,15 @@
      * android:smallScreens}.
      */
     public static final int FLAG_SUPPORTS_SMALL_SCREENS = 1<<9;
-    
+
     /**
      * Value for {@link #flags}: true when the application's window can be
      * displayed on normal screens.  Corresponds to
      * {@link android.R.styleable#AndroidManifestSupportsScreens_normalScreens
      * android:normalScreens}.
      */
-    public static final int FLAG_SUPPORTS_NORMAL_SCREENS = 1<<10; 
-    
+    public static final int FLAG_SUPPORTS_NORMAL_SCREENS = 1<<10;
+
     /**
      * Value for {@link #flags}: true when the application's window can be
      * increased in size for larger screens.  Corresponds to
@@ -206,7 +207,7 @@
      * android:largeScreens}.
      */
     public static final int FLAG_SUPPORTS_LARGE_SCREENS = 1<<11;
-    
+
     /**
      * Value for {@link #flags}: true when the application knows how to adjust
      * its UI for different screen sizes.  Corresponds to
@@ -214,7 +215,7 @@
      * android:resizeable}.
      */
     public static final int FLAG_RESIZEABLE_FOR_SCREENS = 1<<12;
-    
+
     /**
      * Value for {@link #flags}: true when the application knows how to
      * accomodate different screen densities.  Corresponds to
@@ -222,7 +223,7 @@
      * android:anyDensity}.
      */
     public static final int FLAG_SUPPORTS_SCREEN_DENSITIES = 1<<13;
-    
+
     /**
      * Value for {@link #flags}: set to true if this application would like to
      * request the VM to operate under the safe mode. Comes from
@@ -231,10 +232,14 @@
      */
     public static final int FLAG_VM_SAFE_MODE = 1<<14;
 
+    //collaboroid
+    public static final int FLAG_SAMD_APP = 1<<30;
+
+    //public static final int FLAG_REVISE_APP = 2<<1;
     /**
      * Value for {@link #flags}: set to <code>false</code> if the application does not wish
      * to permit any OS-driven backups of its data; <code>true</code> otherwise.
-     * 
+     *
      * <p>Comes from the
      * {@link android.R.styleable#AndroidManifestApplication_allowBackup android:allowBackup}
      * attribute of the &lt;application&gt; tag.
@@ -297,7 +302,7 @@
      * android:xlargeScreens}.
      */
     public static final int FLAG_SUPPORTS_XLARGE_SCREENS = 1<<19;
-    
+
     /**
      * Value for {@link #flags}: true when the application has requested a
      * large heap for its processes.  Corresponds to
@@ -412,6 +417,9 @@
      */
     public int flags = 0;
 
+    //public int samd_flags = 0;
+    //public boolean samd_flags = false;
+
     /**
      * Value for {@link #privateFlags}: true if the application is hidden via restrictions and for
      * most purposes is considered as not installed.
@@ -464,6 +472,7 @@
      */
     public int privateFlags;
 
+
     /**
      * The required smallest screen width the application can run on.  If 0,
      * nothing has been specified.  Comes from
@@ -524,7 +533,7 @@
      * Full paths to the locations of extra resource packages this application
      * uses. This field is only used if there are extra resource packages,
      * otherwise it is null.
-     * 
+     *
      * {@hide}
      */
     public String[] resourceDirs;
@@ -545,7 +554,7 @@
      * the structure.
      */
     public String[] sharedLibraryFiles;
-    
+
     /**
      * Full path to a directory assigned to the package for its persistent
      * data.
@@ -619,7 +628,7 @@
      * the same uid).
      */
     public int uid;
-    
+
     /**
      * The minimum SDK version this application targets.  It may run on earlier
      * versions, but it knows how to work with any new behavior added at this
@@ -718,7 +727,7 @@
     public boolean hasRtlSupport() {
         return (flags & FLAG_SUPPORTS_RTL) == FLAG_SUPPORTS_RTL;
     }
-    
+
     public static class DisplayNameComparator
             implements Comparator<ApplicationInfo> {
         public DisplayNameComparator(PackageManager pm) {
@@ -734,7 +743,7 @@
             if (sb == null) {
                 sb = ab.packageName;
             }
-            
+
             return sCollator.compare(sa.toString(), sb.toString());
         }
 
@@ -744,7 +753,7 @@
 
     public ApplicationInfo() {
     }
-    
+
     public ApplicationInfo(ApplicationInfo orig) {
         super(orig);
         taskAffinity = orig.taskAffinity;
@@ -790,8 +799,8 @@
 
     public String toString() {
         return "ApplicationInfo{"
-            + Integer.toHexString(System.identityHashCode(this))
-            + " " + packageName + "}";
+                + Integer.toHexString(System.identityHashCode(this))
+                + " " + packageName + "}";
     }
 
     public int describeContents() {
@@ -858,7 +867,6 @@
         className = source.readString();
         theme = source.readInt();
         flags = source.readInt();
-        privateFlags = source.readInt();
         requiresSmallestWidthDp = source.readInt();
         compatibleWidthLimitDp = source.readInt();
         largestWidthLimitDp = source.readInt();
@@ -915,7 +923,7 @@
 
     /**
      * Disable compatibility mode
-     * 
+     *
      * @hide
      */
     public void disableCompatibilityMode() {
@@ -923,7 +931,7 @@
                 FLAG_SUPPORTS_SMALL_SCREENS | FLAG_RESIZEABLE_FOR_SCREENS |
                 FLAG_SUPPORTS_SCREEN_DENSITIES | FLAG_SUPPORTS_XLARGE_SCREENS);
     }
-    
+
     /**
      * @hide
      */
@@ -936,7 +944,7 @@
         }
         return pm.getDefaultActivityIcon();
     }
-    
+
     private boolean isPackageUnavailable(PackageManager pm) {
         try {
             return pm.getPackageInfo(packageName, 0) == null;
@@ -952,6 +960,11 @@
         return (privateFlags & ApplicationInfo.PRIVATE_FLAG_FORWARD_LOCK) != 0;
     }
 
+    //collaboroid
+    public boolean isSAMDApp(){
+        return (flags & ApplicationInfo.FLAG_SAMD_APP) != 0;
+    }
+
     /**
      * @hide
      */
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/IPackageManager.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/IPackageManager.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/IPackageManager.aidl	2017-09-27 02:07:48.935736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/IPackageManager.aidl	2017-08-05 18:07:02.569760000 +0900
@@ -130,6 +130,14 @@
     int getFlagsForUid(int uid);
 
     int getPrivateFlagsForUid(int uid);
+    
+    // ADDED FOR COLLABOROID
+    int makeodex(String dexPath, String outPath, String pkgName);
+    int aaptPackage(String resPath, String manifestPath, String outputApk);
+    int aaptAdd(int type, String apkPath, String filePath);
+    int movefile(String srcPath, String dstPath);
+    //ADDED FOR SAMD
+    int aaptPackageWithAssets(String resPath, String assetsPath, String manifestPath, String outputApk);
 
     boolean isUidPrivileged(int uid);
 
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageItemInfo.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageItemInfo.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/PackageItemInfo.java	2017-09-27 02:07:48.939736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/PackageItemInfo.java	2017-01-29 19:57:05.450971000 +0900
@@ -94,6 +94,9 @@
      */
     public int showUserIcon;
 
+    //collaboroid
+    public boolean remoteable;
+
     public PackageItemInfo() {
         showUserIcon = UserHandle.USER_NULL;
     }
@@ -110,6 +113,8 @@
         logo = orig.logo;
         metaData = orig.metaData;
         showUserIcon = orig.showUserIcon;
+        //collaboroid
+        remoteable = orig.remoteable;
     }
 
     /**
@@ -309,6 +314,10 @@
         dest.writeBundle(metaData);
         dest.writeInt(banner);
         dest.writeInt(showUserIcon);
+        //collaboroid
+        boolean[] val = new boolean[1];
+        val[0] = remoteable;
+        dest.writeBooleanArray(val);
     }
     
     protected PackageItemInfo(Parcel source) {
@@ -322,6 +331,10 @@
         metaData = source.readBundle();
         banner = source.readInt();
         showUserIcon = source.readInt();
+        //collaboroid
+        boolean[] val = new boolean[1];
+        source.readBooleanArray(val);
+        remoteable = val[0];
     }
 
     /**
